﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Diagnostics;
using Steema.TeeChart.WPF.Styles;

namespace XamlControls
{
    public class Bar : Series
    {
        Steema.TeeChart.WPF.Styles.Series series = new Steema.TeeChart.WPF.Styles.Bar();

        public override Steema.TeeChart.WPF.Styles.Series SeriesObject
        {
            get
            {
                return series;
            }
            set
            {
                series = value;
            }
        }

        #region Data
        public object Data
        {
            get { return (object)this.GetValue(DataProperty); }
            set { this.SetValue(DataProperty, value); }
        }

        public static readonly DependencyProperty DataProperty = DependencyProperty.Register
        (
          "Data",
          typeof(object),
          typeof(Bar),
          new FrameworkPropertyMetadata
              (
              null,
              FrameworkPropertyMetadataOptions.BindsTwoWayByDefault,
              new PropertyChangedCallback(onDataChanged)
              )
        );

        static void onDataChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            Bar _sender_ctrl = sender as Bar;

            if (_sender_ctrl != null)
            {
                object _data = e.NewValue;

                if (_data != null)
                {
                    if (_data is Array)
                    {
                        Array _ar = _data as Array;

                        if (_ar.Length == 2)
                        {
                            object _x_obj = _ar.GetValue(0);
                            object _y_obj = _ar.GetValue(1);

                            if ((_x_obj != null && _x_obj is Array) &&
                                (_y_obj != null && _y_obj is Array))
                            {
                                Array _x_ar = _x_obj as Array;
                                Array _y_ar = _y_obj as Array;

                                // Datenpunkte nur hinzufügen, wenn X- und Y-Feld die gleiche Länge haben
                                if (_x_ar.Length == _y_ar.Length)
                                {
                                    try
                                    {
                                        _sender_ctrl.SeriesObject.Add(_x_ar, _y_ar);
                                    }
                                    catch (Exception _e)
                                    {
                                        Trace.WriteLine(_e.Message + " " + _e.StackTrace);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        #endregion

        #region Data
        public MultiBars Multibar
        {
            get { return (MultiBars)this.GetValue(MultibarProperty); }
            set { this.SetValue(MultibarProperty, value); }
        }

        public static readonly DependencyProperty MultibarProperty = DependencyProperty.Register
        (
          "Multibar",
          typeof(MultiBars),
          typeof(Bar),
          new FrameworkPropertyMetadata
              (
              MultiBars.None,
              FrameworkPropertyMetadataOptions.BindsTwoWayByDefault,
              new PropertyChangedCallback(onMultibarChanged)
              )
        );

        static void onMultibarChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            Bar _sender_ctrl = sender as Bar;

            if (_sender_ctrl != null)
            {
                if (e.NewValue is MultiBars)
                {
                    (_sender_ctrl.SeriesObject as Steema.TeeChart.WPF.Styles.Bar).MultiBar = (MultiBars)e.NewValue;
                }
            }
        }
        #endregion
    }
}
