﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Diagnostics;
using Steema.TeeChart.WPF.Tools;
using Steema.TeeChart.WPF.Styles;
using System.Drawing;

namespace XamlControls
{
    public class Line : Series
    {
        volatile Steema.TeeChart.WPF.Styles.Series series = new Steema.TeeChart.WPF.Styles.Line();

        public Line()
        {
            ((Steema.TeeChart.WPF.Styles.Line)series).LinePen.Width = 1;
        }

        ~Line()
        {
            series = null;
        }

        public override Steema.TeeChart.WPF.Styles.Series SeriesObject
        {
            get
            {
                return series;
            }
            set
            {
                series = value;
            }
        }

        public object Data
        {
            get { return (object)this.GetValue(DataProperty); }
            set { this.SetValue(DataProperty, value); }
        }

        public static readonly DependencyProperty DataProperty = DependencyProperty.Register
        (
          "Data",
          typeof(object),
          typeof(Line),
          new FrameworkPropertyMetadata
              (
              null,
              FrameworkPropertyMetadataOptions.BindsTwoWayByDefault | FrameworkPropertyMetadataOptions.AffectsRender,
              new PropertyChangedCallback(onDataChanged)
              )
        );

        static void onDataChanged(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            Line _sender_ctrl = sender as Line;

            if (_sender_ctrl != null)
            {
                object _data = e.NewValue;

                if (_data != null)
                {
                    if (_data is Array)
                    {
                        Array _ar = _data as Array;

                        if (_ar is PointF[])
                        {
                            PointF[] _points = _ar as PointF[];

                            _sender_ctrl.SeriesObject.Clear();

                            for(int _i = 0; _i < _points.Length; _i++)
                            {
                                PointF _point = _points[_i];

                                _sender_ctrl.SeriesObject.Add(_point.X, _point.Y);
                            }
                        }
                        else if (_ar.Length == 2)
                        {
                            object _x_obj = _ar.GetValue(0);
                            object _y_obj = _ar.GetValue(1);

                            if ((_x_obj != null && _x_obj is Array) &&
                                (_y_obj != null && _y_obj is Array))
                            {
                                Array _x_ar = _x_obj as Array;
                                Array _y_ar = _y_obj as Array;

                                // Datenpunkte nur hinzufügen, wenn X- und Y-Feld die gleiche Länge haben
                                if (_x_ar.Length == _y_ar.Length)
                                {
                                    try
                                    {
                                        _sender_ctrl.SeriesObject.Add(_x_ar, _y_ar);
                                    }
                                    catch (Exception _e)
                                    {
                                        Trace.WriteLine(_e.Message + " " + _e.StackTrace);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
