﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using System.Drawing;
using Color = System.Windows.Media.Color;

namespace XamlControls
{
    public sealed class SeriesColors
    {
        private static Color[] colors = new Color[] 
        { 
            Colors.Blue, 
            Colors.Green, 
            Colors.Yellow, 
            Colors.Red,
            Colors.Magenta,
            Colors.Cyan,
            Colors.Peru,
            Colors.Pink,
            Colors.Khaki,
            Colors.Black,
            Colors.Olive,
            Colors.Orange,
            Colors.Plum,
            Colors.Brown
        };

        /// <summary>
        /// Liefert für eine Nummer eine eindeutige Farbe zurück. Wenn es für einen Index eine
        /// Farbe nicht gibt, wird das Offset anhand der verfügbaren Farben bestimmt und die
        /// Farbe dafür zurückgegeben.
        /// </summary>
        /// <param name="anIndex"></param>
        /// <returns></returns>
        public static Color GetColorForIndex(int anIndex)
        {
            Color _c = Colors.Transparent;

            if (anIndex < colors.Length)
            {
                _c = colors[anIndex];
            }
            else
            {
                int _idx = anIndex;

                while (_idx >= colors.Length)
                {
                    _idx = _idx - colors.Length;
                }

                _c = colors[_idx];
            }

            return _c;
        }
    }
}
